// FILENAME:  MercsInc.cs
//
// AUTHORS:    Orogogus
//------------------------------------------------------------------------------

$missionName = "Mercenaries, Inc. v0.0.7";

exec("MercsIncMultiplayerStdLib.cs");
exec("MIConfigCosts.cs");

function setDefaultMissionOptions()
{
  $server::TeamPlay = true;
  $server::AllowDeathmatch = false;
  $server::AllowTeamPlay = true;  

   // what can the client choose for a team
  $server::AllowTeamRed = false;
  $server::AllowTeamBlue = true;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = false;	

  // what can the server admin choose for available teams
  $server::disableTeamRed = true;
  $server::disableTeamBlue = false;
  $server::disableTeamYellow = true;
  $server::disableTeamPurple = true;
}


function onMissionStart()
{
}


function onMissionLoad()
{
  $MissionCycling::Stage0 = "MercsInc";

  $MImaxMissions = 7;       // Server ops should set according to preference

  $MIcurrentMission = -1;
  $MIreadyToLaunch = 0;     // 0: no mission selected; 1: not all players logged in; 2: mission launched

  exec("MercsIncPlayerList.cs");
  exec("MercsIncMissionList.cs");
  Mercs::fillMissionList();

  for(%i = 8000; %i<9000; %i++) if(getObjectName(%i) == "AIVehicle") deleteObject(%i);
}

function player::OnAdd(%player)
{
  %player.MIloggedIn = 0;
  %player.MIstartMission = 0;

  say(%player, 0, "Welcome to Mercenaries, Inc.  If you have questions, or if this is your first time on the server, please go to http://home.san.rr.com/orogogus/MercsInc/ first");
}


function player::onRemove(%player)
{
  %count = playerManager::getPlayerCount();
  if(%count == 0) 
  {
    $MissionCycling::Stage0 = "MercsInc";
    $MIcurrentMission = -1;
    $MIreadyToLaunch = 0; 
  }
  if($MIreadyToLaunch == 0) return;
  else Mercs::startCheck3(%player);
}


function vehicle::OnAdd(%vehicle)
{
  %player = playerManager::VehicleIdToPlayerNum(%vehicle);
  %player.MIstartMission = 0;
  %vehicleCost = MIConfigCosts::checkvalue(%vehicle);
  say(%player, 0, "Your vehicle cost is $" @ %vehicleCost @ ".");

}


//======================================


function Mercs::checkPlayerName(%player, %password)
{

  %nameMatch = 0;

  for(%i=0; %i<$MIPlayers; %i++)
  {
    if(getName(%player) == $MIPlayer[%i])
    {
      %nameMatch = 1;

      if(%password != $MIPlayerPassword[%i])
      {
        messagebox(%player, "Sorry, your password doesn't match your name! " @ 
          "Either someone has already registered this name " @
          "or your password is incorrectly configured.  " @ 
          "Please report on the Editing and Scripting board.  Thank you, and enjoy your visit.");
      }
      else
      {
        %player.MImoney = $MIPlayerMoney[%i];
        %player.MIloggedIn = 1;
        %player.MIid = %i;
        say(%player, 0, "Welcome back, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");

        if($MIreadyToLaunch == 1) Mercs::startCheck2();
      }
    }
  }

  if(%nameMatch == 0)    // sign up a new player
  {
    $MIPlayer[$MIPlayers] = getName(%player);
    $MIPlayerPassword[$MIPlayers] = %password;
    Mercs::inscribeRecord();
    %player.MIid = %i;
    $MIPlayers++;

    messagebox(%player, "Welcome to Mercenaries, Inc.  Please excuse the dust.  Have $8000 for testing purposes.");
    %player.MImoney = 0;
    %player.MIloggedIn = 1;
    Mercs::addMoney(%player, 8000);

    if($MIreadyToLaunch == 1) Mercs::startCheck2();
  }
}


function Mercs::addMoney(%player, %money)
{
  %player.MImoney = %player.MImoney + %money;
  if(%player.MImoney < 0) %player.MImoney = 0;
  $MIPlayerMoney[%player.MIid] = %player.MImoney;  
  Mercs::InscribePlayers();
}


function Mercs::cleanMissionList()
{
  if($MImissionCount<2 && $MImission[0] == "empty")
  {
    Mercs::makeMission(0);
  }
  else
  {
    for(%i=0; %i<($MImissionCount-1); %i++)
    {
      if($MImission[%i] == "empty")
      {
        %swapped = 0;
        for(%j=(%i+1); %j<$MImissionCount; %j++)
        {
          if($MImission[%j] != "empty" && %swapped == 0)
          {
            %swapped = 1;
            Mercs::swapMissions(%i, %j);
          }
        }
      }
    }
  }
}


function Mercs::fillMissionList()
{
  $MImissionCount = $MImaxMissions;
  for(%i=0; %i<$MImaxMissions; %i++)
  {
    if($MImission[%i] == "empty" || $MImission[%i] == "")
    {
      Mercs::makeMission(%i);
    }
  }
}


function Mercs::inscribeMissions()
{
  $MIplaceHolder = "Mercenaries, Inc. Mission List";
  export("$MIplaceHolder", "multiplayer\\MercsIncMissionList.cs", overwrite);
  fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionCount = " @ $MImissionCount @ ";");
  fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MItotalMissions = " @ $MItotalMissions @ ";");
  fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "");

  for(%i=0; %i<$MImissionCount; %i++)
  {
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImission[" @ %i @ "] = \"" @ $MImission[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionBountyPercent[" @ %i @ "] = " @ $MImissionBountyPercent[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionDate[" @ %i @ "] = \"" @ $MImissionDate[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionDifficulty[" @ %i @ "] = " @ $MImissionDifficulty[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionLocation[" @ %i @ "] = \"" @ $MImissionLocation[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionNumber[" @ %i @ "] = " @ $MImissionNumber[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionParameters[" @ %i @ "] = " @ $MImissionParameters[%i] @ ";");

    for(%j=0; %j<$MImissionParameters[%i]; %j++)
    {
      fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionParameter[" @ %i @ ", " @ %j @ "] = " @ $MImissionParameter[%i, %j] @ ";");
    }

    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionPay[" @ %i @ "] = " @ $MImissionPay[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionTime[" @ %i @ "] = \"" @ $MImissionTime[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionTransportPercent[" @ %i @ "] = " @ $MImissionTransportPercent[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "$MImissionType[" @ %i @ "] = \"" @ $MImissionType[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionList.cs" , append, "" );
  }
}


function Mercs::inscribePlayers()
{
  $MIplaceHolder = "Mercenaries, Inc. Player List";
  export("$MIplaceHolder", "multiplayer\\MercsIncPlayerList.cs", overwrite);
  fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayers = " @ $MIPlayers @ ";");
  fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "");

  for(%i=0; %i<$MIPlayers; %i++)
  {
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayer[" @ %i @ "] = \"" @ $MIPlayer[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerMoney[" @ %i @ "] = " @ $MIPlayerMoney[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerPassword[" @ %i @ "] = \"" @ $MIPlayerPassword[%i] @ "\";");
  }
}


function Mercs::inscribeRecord()
{
  Mercs::inscribeMissions();
  Mercs::inscribePlayers();
}


function Mercs::launchMission()
{
  $MIreadyToLaunch = 2;
  say(0, 0, "Selection locked.  Mission launches in 5 seconds.");

  $MImission[$MIcurrentMission] = "empty";
  Mercs::inscribeMissions();

  schedule("missionEndConditionMet();", 5);
}


function Mercs::makeMission(%missionNum)
{
//  Date and time format looks like this: 07/04/00, 00:08:49

  exec("MercsIncMissionTemplate.cs");

  %newMission = randomInt(0, (%MImisTemplates - 1) );          // Pick a mission from the mission template
  $MImission[%missionNum] = %MImisTemplate[%newMission];       // Step 1 in creating the new mission
  $MImissionType[%missionNum] = %MImisTemplateType[%newMission];
  $MImissionLocation[%missionNum] = %MImisTemplateLocation[%newMission];
  $MImissionParameters[%missionNum] = %MImisTemplateParameters[%newMission];
  $MImissionDate[%missionNum] = getDate();
  $MImissionTime[%missionNum] = getTime();

  $MItotalMissions++;
  $MImissionNumber[%missionNum] = $MItotalMissions;

  %difficulty = 1;
  for(%i=0; %i<%MImisTemplateParameters[%newMission]; %i++)
  {
    %parameter[%missionNum, %i] = randomInt(%MImisTemplateParameterMin[%newMission, %i], %MImisTemplateParameterMax[%newMission, %i]);
    $MImissionParameter[%missionNum, %i] = %parameter[%missionNum, %i];
    %difficulty = %difficulty * %parameter[%missionNum, %i];
  }
  $MImissionDifficulty[%missionNum] = %difficulty;
  %difficultyMultiplier = %difficulty / %MImisTemplateAvgDifficulty[%newMission];

  $MImissionPay[%missionNum] = Mercs::round(%MImisTemplateBasePay[%newMission] * %difficultyMultiplier * Mercs::statRoll(20, 6));
  $MImissionTransportPercent[%missionNum] = Mercs::round(%MImisTemplateBaseTransportPercent[%newMission] * Mercs::statRoll(20, 6));
  $MImissionBountyPercent[%missionNum] = Mercs::round(%MImisTemplateBaseBountyPercent[%newMission] * %difficultyMultiplier * Mercs::statRoll(20, 6));

  Mercs::inscribeMissions();
}


function Mercs::selectNextMission()
{
  $MIcurrentMission++;
  if($MIcurrentMission >= $MImissionCount) $MIcurrentMission = 0;

  $MissionCycling::Stage0 = $MImission[$MIcurrentMission];

  $MIlocation = $MImissionLocation[$MIcurrentMission];
  $MItype = $MImissionType[$MIcurrentMission];

  %number = $MImissionNumber[$MIcurrentMission];
  %date = $MImissionDate[$MIcurrentMission];
  %Time = $MImissionTime[$MIcurrentMission];

  $MIbountyPercent = $MImissionBountyPercent[$MIcurrentMission];
  $MIdifficulty = $MImissionDifficulty[$MIcurrentMission];  
  $MItransportPercent = $MImissionTransportPercent[$MIcurrentMission];
  $MItotalPay = $MImissionPay[$MIcurrentMission];

  $MImissionParameters = $MImissionParameters[$MIcurrentMission];
  for(%i=0; %i<$MImissionParameters; %i++)  
  {
    $MImissionParameter[%i] = $MImissionParameter[$MIcurrentMission, %i];
  }

  say(0, 0, "Mission #" @ %number @ ", posted " @ %date @ " " @ %time @ " -- " @ $MIlocation @ " (" @ $MItype @ "), difficulty " @ $MIdifficulty @ 
        ".  Total pay: $" @ $MItotalPay @ ", " @ $MIbountyPercent @ "% kill bounty and " @
        $MItransportPercent @ "% transport fees");
}


function Mercs::startCheck(%player)  // when someone sets the mission
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player2 = playerManager::getPlayerNum(%i);
    if(%player2.MIloggedIn != 1)
    {
      %ready = 0;
      say(%player2, 0, "WARNING: Someone has initiated a mission selection, and you are not logged in.  Please log in now if you want to join this mission.");
      %waitingFor++;
    }
  }

  if(%waitingFor != 1) %plural = "s have";
   else %plural = " has";

  if(%ready == 0)
  {
    say(%player, 0, "WARNING: " @ %waitingFor @ " player" @ %plural @ " not logged in yet.  Please confirm that you want to launch this mission anyway.");
  }
  else Mercs::launchMission();
}


function Mercs::startCheck2(%player)   // when someone logs in after the mission has been set
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIloggedIn != 1)
    {
      %ready = 0;
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    if(%waitingFor != 1) %plural = "s.";
     else %plural = ".";

    say(0, 0, getName(%player) @ " has logged in.  Waiting for " @ %waitingFor @ " more player" @ %plural );
  }
  else
  {
    say(0, 0, "All players logged in.");
    Mercs::launchMission();
  }
}


function Mercs::startCheck3(%player)   // when someone quits the server after the mission is set
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIloggedIn != 1)
    {
      %ready = 0;
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    if(%waitingFor != 1) %plural = "s.";
     else %plural = ".";

    say(0, 0, getName(%player) @ " has quit.  Waiting for " @ %waitingFor @ " more player" @ %plural );
  }
  else
  {
    say(0, 0, getName(%player) @ " has quit.  All players are now logged in.");
    Mercs::launchMission();
  }
}


function Mercs::statRoll(%number, %sides)
{
  %total = 0;
  for(%i=0; %i<%number; %i++)
  {
    %die = randomInt(1, %sides);
    %total = %total + %die;
  }
  %average = %total / %number;
  %final = %average / ((%sides+1)/2);
  return(%final);
}


function Mercs::swapMissions(%a, %b)
{
  %MissionA = $MImission[%a];
  %BountyPercentA = $MImissionBountyPercent[%a];
  %DateA = $MImissionDate[%a];
  %DifficultyA = $MImissionDifficulty[%a];
  %LocationA = $MImissionLocation[%a];
  %PayA = $MImissionPay[%a];
  %TimeA = $MImissionTime[%a];
  %TransportPercentA = $MImissionTransportPercent[%a];
  %TypeA = $MImissionType[%a];
  %ParametersA = $MImissionParameters[%a];
  for(%i=0; %i<%ParametersA; %i++)
  {
    %ParameterA[%i] = $MImissionParameter[%a, %i];
  }

  %MissionB = $MImission[%b];
  %BountyPercentB = $MImissionBountyPercent[%b];
  %DateB = $MImissionDate[%b];
  %DifficultyB = $MImissionDifficulty[%b];
  %LocationB = $MImissionLocation[%b];
  %PayB = $MImissionPay[%b];
  %TimeB = $MImissionTime[%b];
  %TransportPercentB = $MImissionTransportPercent[%b];
  %TypeB = $MImissionType[%b];
  %ParametersB = $MImissionParameters[%b];
  for(%i=0; %i<%ParametersB; %i++)
  {
    %ParameterB[%i] = $MImissionParameter[%b, %i];
  }

  $MImission[%a] = %MissionB;
  $MImissionBountyPercent[%a] = %BountyPercentB;
  $MImissionDate[%a] = %DateB;
  $MImissionDifficulty[%a] = %DifficultyB;
  $MImissionLocation[%a] = %LocationB;
  $MImissionPay[%a] = %PayB;
  $MImissionTime[%a] = %TimeB;
  $MImissionTransportPercent[%a] = %TransportPercentB;
  $MImissionType[%a] = %TypeB;
  $MImissionParameters[%a] = %ParametersB;
  for(%i=0; %i<%ParametersB; %i++)
  {
    $MImissionParameter[%a, %i] = %ParameterB[%i];
  }

  $MImission[%b] = %MissionA;
  $MImissionBountyPercent[%b] = %BountyPercentA;
  $MImissionDate[%b] = %DateA;
  $MImissionDifficulty[%b] = %DifficultyA;
  $MImissionLocation[%b] = %LocationA;
  $MImissionPay[%b] = %PayA;
  $MImissionTime[%b] = %TimeA;
  $MImissionTransportPercent[%b] = %TransportPercentA;
  $MImissionType[%b] = %TypeA;
  $MImissionParameters[%b] = %ParametersA;
  for(%i=0; %i<%ParametersA; %i++)
  {
    $MImissionParameter[%b, %i] = %ParameterA[%i];
  }
}


//================================

function remoteMercs::Login(%player, %password)
{
  if(%player.MIloggedIn == 1) say(%player, 0, "You are already logged in, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");
   else Mercs::checkPlayerName(%player, %password);
}

//================================



function missionSelect::structure::OnScan(%scannee, %scanner, %string)
{
  if($MIreadyToLaunch == 2) return;
  Mercs::selectNextMission();
}


function missionSelect::structure::OnAttacked(%target, %attacker)
{
  if($MIreadyToLaunch == 2) return;
  %player = playerManager::vehicleIdToPlayerNum(%attacker);

  if(%player.MIloggedIn == 0)
  {
    say(%player, 0, "Please log in before selecting a mission.");
    return;
  }

  if($MIcurrentMission < 0)
  {
    say(%player, 0, "Please select a mission by scanning the structure first.");
    return;
  }

  if($MIreadyToLaunch == 1)
  {
    Mercs::launchMission();
    return;
  }
  else if($MIreadyToLaunch == 0)
  {
    $MIreadyToLaunch = 1;
    Mercs::startCheck(%player);
  }
}


//======================


function Mercs::round(%number)
{
  %roundNum = %number;
  if(%number > 0)
  {
    %excess = (%number - floor(%number));
    if(%excess >= 0.5)
    {
      %roundNum = (floor(%number) + 1);
    }
    else
    {
      %roundNum = floor(%number);
    }
  }
  if(%number < 0)
  {
    %excess = (floor(%number) - %number);
    if(%excess <= 0.5)
    {
      %roundNum = floor(%number);
    }
    else
    {
      %roundNum = (floor(%number) - 1);
    }
  }
  return %roundNum;
}
